# -*- coding: utf-8 -*-
"""02 Merge Excel files.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/15EmP5nuiQ5aBWf9mLKOI03F1WiV6OH8e

#  Merge Excel files

https://colab.research.google.com/
"""

from google.colab import drive

drive.mount('/content/gdrive')

import pandas


def get_all_sheet_names(url1, url2):

  url1_result = pandas.read_excel(url1, sheet_name=None)

  url2_result = pandas.read_excel(url2, sheet_name=None)

  return url1_result.keys(), url2_result.keys()

url1 = '/content/gdrive/MyDrive/xlsx_files/chart_workbook.xlsx'
url2 = '/content/gdrive/MyDrive/xlsx_files/bubble_chart.xlsx'

url1_sheets, url2_sheets = get_all_sheet_names(url1, url2)

import os 
import openpyxl 

def check_if_file_exists(path):

  if not os.path.exists(path):

    workbook = openpyxl.Workbook()

    workbook.save(path)

destination_path = '/content/gdrive/MyDrive/xlsx_files/new_merged2.xlsx'

check_if_file_exists(destination_path)



def merge(url1_sheet_names, 
      url2_sheet_names, 
      url1, 
      url2, 
      destination_path):
  
  for i in url1_sheet_names:

    data = pandas.read_excel(url1, sheet_name= i )

    with pandas.ExcelWriter(destination_path,
                            engine="openpyxl",
                            mode = "a") as writer:

                            data.to_excel(writer, 
                                          index = False,
                                          sheet_name = i )
                            
  for i in url2_sheet_names:

    data = pandas.read_excel(url2, sheet_name= i )

    with pandas.ExcelWriter(destination_path,
                            engine="openpyxl",
                            mode = "a") as writer:

                            data.to_excel(writer, 
                                          index = False,
                                          sheet_name = i + "_")

  if "Sheet" not in url1_sheet_names and "Sheet" not in url2_sheet_names:

    workbook = openpyxl.load_workbook(destination_path)

    del workbook["Sheet"]

    workbook.save(destination_path)

merge(url1_sheets, 
      url2_sheets, 
      url1, 
      url2, 
      destination_path)

excel_file = pandas.ExcelFile(destination_path)

print(excel_file)

print(excel_file.sheet_names)

for sheet in excel_file.sheet_names:

  dataframe = excel_file.parse(sheet)

  print(dataframe)

excel_file = pandas.ExcelFile(url2)

print(excel_file)

print(excel_file.sheet_names)

for sheet in excel_file.sheet_names:

  dataframe = excel_file.parse(sheet)

  print(dataframe)